#!/bin/bash
#
# SVFE-Adapter startup script
#
# chkconfig: - 74 10
# description: svfe-adapter
# processname: svfe-adapter

# LSB compliant service control script
#
### BEGIN INIT INFO
# Provides:                     SmartVista Front-End Adapter application
# Required-Start:               $ALL
# Should-Start:
# Required-Stop:
# Should-Stop:
# Default-Start:                3 5
# Default-Stop:                 0 1 6
# Short-Description:            svfe-adapter
# Description:                  Starts and stops svfe-adapter
### END INIT INFO

########################################
#  BEGIN OF THE CONFIGURATION SECTION  #
########################################

##Rev8
#stop section changed to send stop to the binary and KILL signal
##Rev9
#binary startup arguments chnaged
#Solaris support
##Rev10
## Logger option for AIX changed to -puser.debug
##Rev11
##Linux SystemD support
##Rev12
##Function stop: eval added
##Rev13
#AIX bug fixes
###Rev14
#Veritas Cluster support on exit code 100
###Rev15
#Status by PID file

SV_OWNER={{ svfe_user }}

#-------------------------------------------
AD_PID=/tmp/{{ svfe_adapter_pid_file | default('svfe_adapter_pid_svfe') }}
AD_BINARY=svfe_adapter

LOCK_FILE=/tmp/svfe-adapter_lock

#-------------------------------------------
#If running in Cluster environment set USE_CLUSER variable to TRUE otherwise set it to FALSE.
USE_CLUSTER="TRUE"

#Shutdown Message
SHUT_MSG="SmartVista Front-End Adapter shutdown succeeded"

#-------------------------------------------
#Debug options
DEBUG_ENABLED={{ svfe_adapter_debug_enabled }}
DEBUG_FILE_NAME={{ svfe_adapter_debug_file_name }}
KI_VERBOSE=1
KI_QUIET=0

######################################
#  END OF THE CONFIGURATION SECTION  #
######################################

echo_success() {
    [ "$BOOTUP" = "color" ] && $MOVE_TO_COL
    echo -n "["
    [ "$BOOTUP" = "color" ] && $SETCOLOR_SUCCESS
    echo -n $"  OK  "
    [ "$BOOTUP" = "color" ] && $SETCOLOR_NORMAL
    echo -n "]"
    echo -ne "\r"
    return 0
}

echo_failure() {
    [ "$BOOTUP" = "color" ] && $MOVE_TO_COL
    echo -n "["
    [ "$BOOTUP" = "color" ] && $SETCOLOR_FAILURE
    echo -n $"FAILED"
    [ "$BOOTUP" = "color" ] && $SETCOLOR_NORMAL
    echo -n "]"
    echo -ne "\r"
    return 1
}

#Create lock file to exlude multiply instances of the script

function create_lock_file() {
    if [ "$USE_CLUSTER" == "FALSE" ]
        then
            if [ -e $LOCK_FILE ]
                then
                    echo "Another instance of the script running... Or check for lock file: $LOCK_FILE"
                    exit 255
            fi
                touch $LOCK_FILE
        else
            echo ""
            echo "Assuming using script in the Cluster Environment"
            echo "Multiply instances of script is permited. Cluster must take care about it"
            echo ""
    fi
}

function remove_lock_file() {
    if [ "$USE_CLUSTER" == "FALSE" ]
        then
            rm -f $LOCK_FILE
    fi
}

prog="SVFE Adapter"

SV_FOLDER=`grep "^${SV_OWNER}:" /etc/passwd | cut -d ':' -f 6`

#Debug file location.
if [ "$USER" == "" ] || [ "$USER" == "root" ]
        then
                DEBUG_FILE=/var/log/${DEBUG_FILE_NAME}
        else
                DEBUG_FILE=${SV_FOLDER}/${DEBUG_FILE_NAME}
fi

#Redirect output for debugging

if [ $DEBUG_ENABLED == "TRUE" ]
        then
                DEBUG_REDIRECT=">> ${DEBUG_FILE} 2>&1"
fi

log()
{
        echo `date '+%F %H:%M:%S'` `hostname` "$LOGNAME: $*" >> "$DEBUG_FILE"
        [ $KI_VERBOSE -ne 0 -a $KI_QUIET -eq 0 ] && echo `date '+%F %H:%M:%S'` `basename $0`": $*"
}

msg()
{
        if [ $DEBUG_ENABLED == "TRUE" ]
                then
                        log "$*"
                        [ $KI_VERBOSE -eq 0 -a $KI_QUIET -eq 0 ] && echo "$*"
        fi
}

wrap_exec()
{
        if [ $DEBUG_ENABLED == "TRUE" ]
                then
                        log "--- Executing $* ---"
                        $* | tee -a "$DEBUG_FILE"
                        log "--- Exit of $* ---"
        fi
}


case `uname` in
    AIX)
        OS=AIX
        GREP=`which grep`
        PCMD="ps -p $(cat $AD_PID) -o pid= | wc -l"
        SHUT_LOG_CMD="/usr/bin/logger -puser.debug -t svfe-adapter '${SHUT_MSG}'"
        ;;
    Linux)
        LINUX_RELEASE=`cat /etc/redhat-release | awk '{print $7}' | cut -d. -f1`
        OS=Linux
        GREP=`which grep`
        PCMD="pgrep -u $SV_OWNER -F $AD_PID -c"
        SHUT_LOG_CMD="/usr/bin/logger -t svfe-adapter '${SHUT_MSG}'"
        ;;
    SunOS)
        OS=SunOS
        GREP=/usr/xpg4/bin/grep
        PCMD="pgrep -u $SV_OWNER -F $AD_PID -c"
        SHUT_LOG_CMD="/usr/bin/logger -t svfe-adapter '${SHUT_MSG}'"
        ;;
    *)
        echo "Cant determine OS"
        ;;
esac

SV_FOLDER=`$GREP "^${SV_OWNER}:" /etc/passwd | cut -d ':' -f 6`

if [ -e ${SV_FOLDER}/.profile ]
        then
        profile_file=${SV_FOLDER}/.profile
    else
        profile_file=${SV_FOLDER}/.bash_profile
fi

. $profile_file > /dev/null 2>&1

if [ "${ADAPTER_HOME}x" == "x" ]
    then
        echo "ADAPTER_HOME variable hasnt been specified. Using Default value"
        ADAPTER_HOME=${SV_FOLDER}/adapter
fi

adapter=${ADAPTER_HOME}/bin/${AD_BINARY}
LOG_FILE=${ADAPTER_HOME}/adapter_start.log

case "$OS" in
    Linux)
        case "$USER" in
            root)
                START_CMD="su - $SV_OWNER -c \". $profile_file; export ADAPTER_HOME=$ADAPTER_HOME;$adapter start > $LOG_FILE\""
                STOP_CMD="su - $SV_OWNER -c \". $profile_file; export ADAPTER_HOME=$ADAPTER_HOME; $adapter stop\""
                ;;

            $SV_OWNER)
                START_CMD="export ADAPTER_HOME=$ADAPTER_HOME; $adapter start > $LOG_FILE"
                STOP_CMD="export ADAPTER_HOME=$ADAPTER_HOME; $adapter stop"
                ;;
            *)
                START_CMD="su - $SV_OWNER -c \". $profile_file; export ADAPTER_HOME=$ADAPTER_HOME;$adapter start > $LOG_FILE\""
                STOP_CMD="su - $SV_OWNER -c \". $profile_file; export ADAPTER_HOME=$ADAPTER_HOME; $adapter stop\""
                ;;
        esac
        ;;
    AIX)
        case "$USER" in
            root)
                START_CMD="su $SV_OWNER -c \". $profile_file;export SV_HOME=$SV_FOLDER;export ADAPTER_HOME=$ADAPTER_HOME;$adapter start > $LOG_FILE\""
                STOP_CMD="su - $SV_OWNER -c \". $profile_file; export ADAPTER_HOME=$ADAPTER_HOME; $adapter stop\""
                ;;
            $SV_OWNER)
                START_CMD="export ADAPTER_HOME=$ADAPTER_HOME; $adapter start > $LOG_FILE"
                STOP_CMD="export ADAPTER_HOME=$ADAPTER_HOME; $adapter stop"
                ;;
            *)
                START_CMD="su $SV_OWNER -c \". $profile_file;export SV_HOME=$SV_FOLDER;export ADAPTER_HOME=$ADAPTER_HOME;$adapter start > $LOG_FILE\""
                STOP_CMD="su $SV_OWNER -c \". $profile_file; export ADAPTER_HOME=$ADAPTER_HOME; $adapter stop\""
                ;;
        esac
        ;;
    SunOS)
        case "$USER" in
            root)
                START_CMD="su - $SV_OWNER -c \". $profile_file; export ADAPTER_HOME=$ADAPTER_HOME;$adapter start > $LOG_FILE\""
                STOP_CMD="su - $SV_OWNER -c \". $profile_file; export ADAPTER_HOME=$ADAPTER_HOME; $adapter stop\""
                ;;
            $SV_OWNER)
                START_CMD="export ADAPTER_HOME=$ADAPTER_HOME; $adapter start > $LOG_FILE"
                STOP_CMD="export ADAPTER_HOME=$ADAPTER_HOME; $adapter stop"
                ;;
            *)
                START_CMD="su - $SV_OWNER -c \". $profile_file; export ADAPTER_HOME=$ADAPTER_HOME;$adapter start > $LOG_FILE\""
            STOP_CMD="su - $SV_OWNER -c \". $profile_file; export ADAPTER_HOME=$ADAPTER_HOME; $adapter stop\""
                ;;
        esac
        ;;
esac

ERROR_PS_CMD="ps -ef | $GREP svfe_adapter | $GREP -v grep"

EXIT_CODE=0

BOOTUP=color
RES_COL=60
MOVE_TO_COL="echo -en \\033[${RES_COL}G"
SETCOLOR_SUCCESS="echo -en \\033[1;32m"
SETCOLOR_FAILURE="echo -en \\033[1;31m"
SETCOLOR_WARNING="echo -en \\033[1;33m"
SETCOLOR_NORMAL="echo -en \\033[0;39m"

echo_success() {
  [ "$BOOTUP" = "color" ] && $MOVE_TO_COL
  echo -n "["
  [ "$BOOTUP" = "color" ] && $SETCOLOR_SUCCESS
  echo -n $"  OK  "
  [ "$BOOTUP" = "color" ] && $SETCOLOR_NORMAL
  echo -n "]"
  echo -ne "\r"
  return 0
}

echo_failure() {
  [ "$BOOTUP" = "color" ] && $MOVE_TO_COL
  echo -n "["
  [ "$BOOTUP" = "color" ] && $SETCOLOR_FAILURE
  echo -n $"FAILED"
  [ "$BOOTUP" = "color" ] && $SETCOLOR_NORMAL
  echo -n "]"
  echo -ne "\r"
  return 1
}

function start {
    if [ -e $AD_PID ]
        then
            rm -f $AD_PID
    fi
    echo -en "Starting $prog: "
    OUTPUT=`eval $START_CMD`
    START_RC=$?
    echo $OUTPUT | egrep -e '(Failed|Error)' > /dev/null
    LOG_RC=$?
    if [ $START_RC -eq 0 ] && [ $LOG_RC -ne 0 ]
        then
            EXIT_CODE=0
        else
            EXIT_CODE=255
    fi
}

function stop {
    echo "Stopping $prog: "
    echo "Sending STOP command to the binary"
    OUTPUT=`eval $STOP_CMD`
    sleep 2
    eval $PCMD | $GREP -e "[0-9]" > /dev/null
    if [ $? -eq 0 ]
        then
            echo "Sending TERM signal to processes if any"
            eval $PCMD | xargs kill
            if [ $? -eq 0 ]
                then
                    EXIT_CODE=0
                else
                    EXIT_CODE=255
            fi
            echo "Waiting for process stop..."
            sleep 2
        else
            EXIT_CODE=0
    fi
    eval $PCMD | $GREP -e "[0-9]" > /dev/null
    if [ $? -eq 0 ]
        then
            echo "Sending KILL signal to processes if any"
            eval $PCMD | xargs kill -9

            sleep 1
    fi
    rm -f $AD_PID
    eval $SHUT_LOG_CMD
}

function status {

#### Solaris CLuster
#Keep in mind solaris cluster accepts exit codes from 1 to 99 as degrated and 100 as fatal
#use exit code 100 or higher for Solaris Cluster
#use exit code 100 for Veritas Cluster

    echo -n $"Trying to check if $prog is alive: "
    CMD_RESULT=`eval $PCMD`
    if [ $CMD_RESULT -eq 1 ]
        then
            EXIT_CODE=0
        else
                        EXIT_CODE=100
                        msg "checking PID file"
                        if [ -e $AD_PID ]
                                then
                                        wrap_exec "ls -la $AD_PID"
                                        msg "checking PID:"
                                        wrap_exec "cat $AD_PID"
                                else
                                        msg "There is no $AD_PID file"
                        fi
                        msg "cheking processes:"
                        wrap_exec "eval $ERROR_PS_CMD"
    fi

}

case "$1" in
    start)
        msg "Executing script with option START..."
        create_lock_file
        if [ "$UNAME" == "Linux" ] && [ $LINUX_RELEASE -lt 7 ]
            then
                touch /var/lock/subsys/svfe-adapter
        fi
        start
        remove_lock_file
        ;;
    stop)
        msg "Executing script with option STOP..."
        create_lock_file
        stop
        if [ "$OS" == "Linux" ] && [ $LINUX_RELEASE -lt 7 ]
            then
                rm -f /var/lock/subsys/svfe
        fi
        remove_lock_file
        ;;
    status)
        msg "Executing script with option STATUS..."
        status
        ;;
    print)
        echo "Start command:"
        echo $START_CMD
        echo
        echo "Profile:"
        echo $profile_file
        ;;
    *)
    echo "Usage: $0 {start,stop,status,print}"
    exit 1
esac

[ $EXIT_CODE -eq 0 ] && echo_success
[ $EXIT_CODE -ne 0 ] && echo_failure
echo

msg "Exiting with EXIT_CODE: $EXIT_CODE"
exit $EXIT_CODE
